<?xml version="1.0"?>
<ArrayOfFBEvent xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <FBEvent>
    <User>Dan McFadden</User>
    <Comment />
    <StatusString>Edited</StatusString>
    <TimeStamp>2023-05-24T20:48:48Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Dan McFadden</User>
    <Comment />
    <StatusString>ReleaseNoted</StatusString>
    <TimeStamp>2023-02-15T00:14:57Z</TimeStamp>
    <ReleaseNote>Addresses an issue during database migration</ReleaseNote>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Justin Richardson</User>
    <Comment />
    <StatusString>Edited</StatusString>
    <TimeStamp>2023-02-02T20:27:54Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Justin Richardson</User>
    <Comment />
    <StatusString>Edited</StatusString>
    <TimeStamp>2023-02-02T20:27:15Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Justin Richardson</User>
    <Comment />
    <StatusString>Edited</StatusString>
    <TimeStamp>2023-02-02T20:26:17Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Justin Richardson</User>
    <Comment>Verified with Datapro  4.0.840.48176 when Migrating from 4.0.784.48023   and having a test setup with multiple ROI .
 
No error messages were displayed on test setup and all ROI were still valid in the test setup .</Comment>
    <StatusString>Closed</StatusString>
    <TimeStamp>2023-02-02T19:18:20Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>Closed</Status>
  </FBEvent>
  <FBEvent>
    <User>Justin Richardson</User>
    <Comment />
    <StatusString>Edited</StatusString>
    <TimeStamp>2023-02-02T18:16:22Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Justin Richardson</User>
    <Comment />
    <StatusString>Assigned</StatusString>
    <TimeStamp>2023-02-02T00:15:36Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Jerry Lawrence</User>
    <Comment>48157, 48161, 48162, 48163, 48164, 48165, 48167, 48168, 48169, 48170, 48171, 48173, 48174, 48175, 48176 are 4.0.</Comment>
    <StatusString>Resolved</StatusString>
    <TimeStamp>2023-02-01T23:13:49Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>Resolved</Status>
  </FBEvent>
  <FBEvent>
    <User>Jerry Lawrence</User>
    <Comment>To test:

Create a Test Setup in 4.0.784 which contains multiple ROIs.

Install DataPRO and migrate from the 4.0.784 database.

Ensure that no error message was displayed.

Run the newly-installed version of DataPRO and ensure that the multiple ROIs are correct.</Comment>
    <StatusString>Edited</StatusString>
    <TimeStamp>2023-02-01T23:09:57Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Jerry Lawrence</User>
    <Comment>Steps taken to diagnose problem:

1) Changed the deserializer used in database migration from System.Web.Script.Serialization.JavaScriptSerializer to Newtonsoft.Json, based on input from Dan who used this deserializer in the GroupList project due to recommendation from Microsoft here https://learn.microsoft.com/en-us/dotnet/api/system.web.script.serialization.javascriptserializer?redirectedfrom=MSDN&amp;view=netframework-4.8  which states, "For .NET Framework 4.7.2 and later versions, use the APIs in the System.Text.Json namespace for serialization and deserialization. For earlier versions of .NET Framework, use Newtonsoft.Json. This type was intended to provide serialization and deserialization functionality for AJAX-enabled applications.".  We are on .NET 4.5.2.

Since the actual call to the deserializer is in Migrations.cs, I added a reference to Newtonsoft.Json to the DTS.Common.Storage project.

2) Added a reference to the new deserializer in the DBConfiguration project.

3) Added packages.config to the DBConfiguration project.

4) Added packages.config to the DTS.Common.Storage project. 

5) Added Newtonsoft.Json.dll and .xml to the .../InstallerCustomActions folder in the installer.  This caused an Exception in GroupList.

6) Changed the SpecificVersion property of Newtonsoft.Json to False in attempt to fix Exception in GroupList when editing a Test Setup. No help, so changed back to True.  No help, so removed Newtonsoft.Json.dll and .xml from the installer.

7) Determined that Newtonsoft.Json.dll (and possibly .xml) are required to be in the InstallerCustomActions folder by copying them in manually after installing DataPRO, but before running the migration code.

8) Found that the static bool Deserializing evaluates to False in NotifyChanged(), after setting to True, when running the migration code from the setup.exe file, so refrained from calling NotifyChanged() when deserializing by checking it in the RegionOfInterest class instead.

9) Returned to System.Web.Script.Serialization.JavaScriptSerializer from Newtonsoft.Json when migrating databases, to avoid issue caused when installing Newtonsoft.Json.dll and Newtonsoft.Json.xml from installer (causes crash when GroupList project is used).


</Comment>
    <StatusString>Edited</StatusString>
    <TimeStamp>2023-02-01T23:08:06Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Jerry Lawrence</User>
    <Comment />
    <StatusString>Edited</StatusString>
    <TimeStamp>2023-01-31T22:53:56Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Jerry Lawrence</User>
    <Comment />
    <StatusString>Assigned</StatusString>
    <TimeStamp>2023-01-31T22:30:56Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Dan McFadden</User>
    <Comment />
    <StatusString>Edited</StatusString>
    <TimeStamp>2023-01-31T18:20:20Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Jerry Lawrence</User>
    <Comment />
    <StatusString>Assigned</StatusString>
    <TimeStamp>2023-01-30T22:51:26Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Jerry Lawrence</User>
    <Comment>Migration works in 4.1, and in 4.0 when using Visual Studio, but not when using the 4.0 build.</Comment>
    <StatusString>Opened</StatusString>
    <TimeStamp>2023-01-30T22:51:26Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>Opened</Status>
  </FBEvent>
</ArrayOfFBEvent>